%define	pkg_name	re2
%define	soname		0
Name:           lib%{pkg_name}-0
Version:        20131024
Release:        1.13

Summary:        C++ fast alternative to backtracking RE engines

Group:          System Environment/Libraries
License:        BSD
URL:            http://code.google.com/p/%{pkg_name}/
Source0:        http://re2.googlecode.com/files/%{pkg_name}-%{version}.tgz
BuildRoot:      %(mktemp -ud %{_tmppath}/%{pkg_name}-%{version}-%{release}-XXXXXX)
BuildRequires:	gcc-c++

%description
RE2 is a C++ library providing a fast, safe, thread-friendly alternative to
backtracking regular expression engines like those used in PCRE, Perl, and
Python.

Backtracking engines are typically full of features and convenient syntactic
sugar but can be forced into taking exponential amounts of time on even small
inputs.

In contrast, RE2 uses automata theory to guarantee that regular expression
searches run in time linear in the size of the input, at the expense of some
missing features (e.g back references and generalized assertions).

%package    -n %{pkg_name}-devel
Summary:        C++ header files and library symbolic links for %{name}
Group:          Development/Libraries
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description   -n %{pkg_name}-devel
This package contains the C++ header files and symbolic links to the shared
libraries for %{name}. If you would like to develop programs using %{name},
you will need to install %{name}-devel.


%prep
%setup -q -n %{pkg_name}

%build
# The -pthread flag issue has been submitted upstream:
# http://groups.google.com/forum/?fromgroups=#!topic/re2-dev/bkUDtO5l6Lo
# The RPM macro for the linker flags does not exist on EPEL
%{!?__global_ldflags: %global __global_ldflags -Wl,-z,relro}
CXXFLAGS="${CXXFLAGS:-%optflags}"
LDFLAGS="${LDFLAGS:-%__global_ldflags} -pthread"
make %{?_smp_mflags} CXXFLAGS="$CXXFLAGS" LDFLAGS="$LDFLAGS" includedir=%{_includedir} libdir=%{_libdir}

%install
rm -rf $RPM_BUILD_ROOT
make install INSTALL="install -p" DESTDIR=$RPM_BUILD_ROOT includedir=%{_includedir} libdir=%{_libdir}

# Suppress the static library
find $RPM_BUILD_ROOT -name 'lib%{name}.a' -exec rm -f {} \;

%check
##make %{?_smp_mflags} test

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS CONTRIBUTORS LICENSE README
%{_libdir}/lib%{pkg_name}.so.*

%files -n %{pkg_name}-devel
%defattr(-,root,root)
%{_includedir}/%{pkg_name}
%{_libdir}/lib%{pkg_name}.so
%{_libdir}/lib%{pkg_name}.a

%changelog

